<?php
/*
Plugin Name: Extra &raquo; FavIcon
Description: allows you to upload and set fav icons for the admin page and the website page.
Version: 1.0.0
Author: Edesa C
Author URI: http://webdev-tuts.com
Plugin URI: http://www.webdev-tuts.com/free-wp-plugins
*/

new ExtraFavIcon();

class ExtraFavIcon {

    public function __construct()
    {       
        add_action('admin_menu', array($this, 'the_sub_menu'));
        add_action('admin_head', array($this, "load_css"));
        add_action('wp_head', array($this, 'load_website_favicon'));
        add_action('admin_head', array($this, 'load_admin_favicon'));
        
        add_action( 'admin_enqueue_scripts', array($this, 'load_custom_code'));    
    }
    
    function load_custom_code() {
        $plugin_url = plugin_dir_url(__FILE__);
        wp_enqueue_media();
        wp_enqueue_script('jquery');        
        wp_enqueue_script('efi-main-scripts', $plugin_url . '/scripts/main-scripts.js');
        
    }
    

    public function the_sub_menu() {
        add_menu_page('Extra', 'Extra', 'administrator', 'extra', array($this, 'extra'));
        add_submenu_page('extra', 'Fav Icon', 'Fav Icon', 'administrator', 'extra-fav-icon',  array($this, 'display'));
        //add_options_page('E favico', 'E Favico', 'administrator', 'e-favico', 'display');
    }

    public function extra()
    {
        echo '<div class="wrap">';
        echo '<h1>Extra</h1>';
        ?>
        <ul>
            <li><a href="<?php echo admin_url() ?>admin.php?page=extra-fav-icon">Set Dashboard and Website Frav Icon</a></li>
        </ul>
        <?php
        echo '</div>';
    }
    
    public function display() {
        echo '<div class="wrap">';
        echo '<h1>Extra &raquo; Favicon</h1>';

        $r = get_option("extra-favicon");
        
        if($_POST['sub_favico'] == 1){
            $w_ext = pathinfo($_POST['website-favicon'], PATHINFO_EXTENSION);
            $a_ext = pathinfo($_POST['admin-favicon'], PATHINFO_EXTENSION);

            $error1 = (!in_array($w_ext, array('ico'))) ? true : false;
            $error2 = (!in_array($a_ext, array('ico'))) ? true : false;

            if(($error1 || $_POST['website-favicon'] == '') || ($error2 || $_POST['admin-favicon'] == '')){
                $msg = 'Changes not saved. You have uploaded an invalid fav icon.';
                $r = $_POST;
            }
            else{
                if($msg == ''){
                    $newvalue['admin-favicon'] = $_POST['admin-favicon'];                    
                    $newvalue['website-favicon'] = $_POST['website-favicon'];

                    $newvalue['enable-admin-icon'] = ($_POST['enable-admin-icon'] == 'on') ? 'on' : 'off';
                    $newvalue['enable-website-icon'] = ($_POST['enable-website-icon'] == 'on') ? 'on' : 'off';
                    $msg = 'Successfully updated dashboard and website favicon.';
                    update_option("extra-favicon", $newvalue);
                    $r = get_option("extra-favicon");
                }
            }

            echo '<div class="updated">' . "\n"
                .   '<p>'
                        . '<strong>'
                        . __($msg, 'race_diary')
                        . '</strong>'
                .   '</p>' . "\n"
                .'</div>' . "\n";
            
        }

        ?>
            <form name="frm-favico" id="frm-favico" action="" method="post" enctype="multipart/form-data">
                <p><em style="color: red">Refresh the browser for the changes to take effect!</em></p>
                <div><label for="favico_blog">Website</label> <input title="Enable" type="checkbox" name="enable-website-icon" <?php echo ($r['enable-website-icon'] == 'on') ? 'checked="checked"' : "" ?> /> <img src="<?php echo $r['website-favicon'] ?>" /></div>
                <div class="uploader">
                    <input id="website-favicon" name="website-favicon" type="text" value="<?php echo $r['website-favicon'] ?>" />
                    <input class="button media-uploader" rel="website-favicon" type="button" value="Upload" />
                </div>
                <br />
                <div><label for="favico_blog">Dashboard</label> <input title="Enable" type="checkbox" name="enable-admin-icon" <?php echo ($r['enable-admin-icon'] == 'on') ? 'checked="checked"' : "" ?> /> <img src="<?php echo $r['admin-favicon'] ?>" /></div>
                <div class="uploader">
                    <input id="admin-favicon" name="admin-favicon" type="text" value="<?php echo $r['admin-favicon'] ?>" />
                    <input class="button media-uploader" rel="admin-favicon" type="button" value="Upload" />
                </div>

                <input type="hidden" name="sub_favico" value="1"/>
                <div class="submit"><input type="submit" class="button-primary" value="Save"/></div>                
            </form>
        <?php
        echo '</div>';
    }

    public function load_css(){
        echo '
                <style type="text/css">
                #frm-favico label{
                        font-weight:bold; display:block; float:left; width:79px;
                }
                .prev_favico{
                        border:solid #E3E3E3 1px; width:120px; height:120px; margin-left:79px;
                }
                .prev_favico legend{
                        font-size:10px; color:#B1B0B0; margin-left:5px;
                }
                input.text{
                        width:100px;
                }
                </style>
        ';
    }

    public function load_admin_favicon(){
        $r = get_option("extra-favicon");
        if($r['enable-admin-icon'] == 'on') {
            echo '<link rel="shortcut icon" type="image/x-icon" href="'. $r['admin-favicon'] . '">';
        }
    }

    public function load_website_favicon(){
        $r = get_option("extra-favicon");
        if($r['enable-website-icon'] == 'on') {
            echo '<link rel="shortcut icon" type="image/x-icon" href="'. $r['website-favicon'] . '">';
        }
    }
}
?>
